( Address book - Short                                      11/04/93 )
(                                                                    )
( 11/04/93	Modified to put out all phone #s for each entry      )
(                                                                    )
( This code removes trailing \n from fields. This needs to be fixed  )
( in S-Engine, and the code removed.                                 )

variable fd.out

10   constant <nl>

4096 string out.buf

80 string name
32 string bphone
32 string aphone
32 string hphone
32 string fax
80 string title
80 string category
80 string company
80 string addr1
80 string addr2
80 string city
80 string st
16 string zip
4096 string note

35 right_margin !
0 left_margin !

: clear		( address --- )
   0 swap c!
   ;
: >here		( 'string --- 'here )
   here 20 0 fill
   count here swap cmove
   here
   ;
: strapp	( 'string ch --- )
   swap dup strlen + 		\ Calculate end addr of string
   dup 1+			\ Calculate end +1
   0 swap !			\ Add a null to make sure it is properly terminated
   c!				\ Append char to it
   ;
: un.newline		( 'string --- )
   dup strlen + 1- 		\ Calc address
   dup c@ <nl> =		\ Compare last char to newline
   if
     0 swap c!			\ yes, trash it
   else
     drop
   endif
   ;
: blank.out.buf
   out.buf "                                                                " 
     1+ strcpy drop
   ;
: output.line		( 'string --- )
   fd.out @ fputline drop drop
   ;
: output.phone#		( 'phone --- )
   dup strlen 0>
   if
     dup out.buf 20 + over strlen cmove
     strlen 20 + out.buf + 0 swap c!
     out.buf output.line
   else
     drop
   endif
   ;
: clear.fields		( --- )
   name clear      bphone clear 
   aphone clear    hphone clear 
   fax clear       title clear 
   category clear  company clear 
   addr1 clear     addr2 clear 
   city clear      st clear 
   zip clear       note clear 
   ;
: .so
   " .so hplj." 1+ output.line
   " .so macros.rof" 1+ output.line
   ;
: .rl
   out.buf " .rl " 1+ strcpy drop
   out.buf 34 strapp
   out.buf "     L--l---l-----------------------------R" 1+ strcat drop
   out.buf 34 strapp
   out.buf output.line
   ;
: setup.rof
   " .nf" 1+ output.line
   " .pl 46" 1+ output.line
   " .he /SGML Phone Book///" 1+ output.line
   " .fo //-#-//" 1+ output.line
\   " .bp 1" 1+ output.line
   ;

: <ADDRESS>
   ." The SGML-based Address Book" cr cr
   " address.rof" >here WRITE fopen
dup ." FD: " . cr
   fd.out !
   .so .rl
   setup.rof
   clear.fields
   ;
: </ADDRESS> 
   fd.out @ fclose
   ;

: <ENTRY>  ;
: </ENTRY> 
   blank.out.buf
   name strlen 0>
   if    ( There is a name field )
      name out.buf name strlen cmove
   else  ( use the company name  )
      company out.buf company strlen cmove
      company clear
   endif 
   bphone strlen 0=
   if ( Blank bphone field )		\ Use hphone if no bussiness phone
      bphone hphone strcat drop
      hphone clear
   endif
   bphone output.phone#
   blank.out.buf
   ascii H out.buf 18 + c!
   hphone output.phone#
   blank.out.buf
   ascii F out.buf 18 + c!
   fax output.phone#
   blank.out.buf
   ascii A out.buf 18 + c!
   aphone output.phone#
   clear.fields
   ;

: <NAME>	name read_into    ;
: </NAME>	name un.newline   ;

: <BPHONE>	bphone read_into  ;
: </BPHONE>	bphone un.newline ;

: <APHONE>	aphone read_into  ;
: </APHONE>	aphone un.newline ;

: <HPHONE>	hphone read_into  ;
: </HPHONE>	hphone un.newline ;

: <FAX> 	fax read_into     ;
: </FAX>	fax un.newline    ;

: <TITLE>	title read_into   ;
: </TITLE>	title un.newline  ;

: <CATEGORY>	category read_into  ;
: </CATEGORY>	category un.newline ;

: <COMPANY>	company read_into   ;
: </COMPANY>	company un.newline  ;

: <ADDR1>	addr1 read_into     ;
: </ADDR1>	addr1 un.newline    ;

: <ADDR2>	addr2 read_into     ;
: </ADDR2>	addr2 un.newline    ;

: <CITY>	city read_into      ;
: </CITY>	city un.newline     ;

: <ST>		st read_into        ;
: </ST>		st un.newline       ;

: <ZIP>		zip read_into       ;
: </ZIP>	zip un.newline      ;

: <NOTE>	note read_into      ;
: </NOTE>	note un.newline     ;

\ sviewer
